%HEAT_1d_IMPL.M----------------------------------------------
clear
clc
D = 1;              %DIFFUSION CONSTANT
L = 1;              %LENGTH OF MODEL
dx=0.01;            %DELTA X
x=0:dx:L;           %COORDINATE ARRAY
N=length(x);        %Number of points
n= zeros(N,1);      %INITIAL CONDITION
n(end) = 1;         %BOUNDARY CONDITION
dt = 0.45*dx^2/D;   %TIME STEP
%dt = 0.5*dx/D;      %TIME STEP
T = 10000;            %NUMBER OF TIMESTEPS

%SETUP OF MATRIX
eta=dx^2/(dt*D);


%et=dt./dx.^2;
e=ones(N,1);
%A=spdiags([-et.*e (1+2*et).*e -et.*e], -1:1, N, N);

M=spdiags([-e e*(2+eta) -e], -1:1, N,N);


%d0=ones(1,N)*(2+eta);
%d1=-ones(1,N-1);
%M=diag(d0)+diag(d1,-1)+diag(d1,1);
M(1,1:2) = [1 0];
M(N, N-1:N) = [0 1];

%TIME LOOP
for t=1:T
    Rhs = eta*n;       %UPDATE RIGHT HAND SIDE
    Rhs(1)=0;
    Rhs(end)=1;
    n = M\Rhs;         %SOLVE SYSTEM
    if mod(t,100)==0     %PLOT
        plot(x,n, '-b');
        drawnow;
        %pause(0.1)
    end
end
%grid on;
%xlabel('Distance');
%ylabel('Temperature');
%title('Temperature Evolution');
%HEAT_1d_IMPL.M----------------------------------------------